CON
        _clkmode = xtal1 + pll16x                                               'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000

CON     'Socket Settings
  DataSocket   = 0
  DatabasePort = 80
  DBstartPort  = 5000
  DBendPort    = 5500
  DBtimeOut    = 1000
  BuffSize     = $800           'equivalent to entire socket buffer on WIZnet
  SNTPsocket   = 1
  SunSocket    = 2
  SunPort      = 80

  Latitude     = 00.000
  Longitude    = -00.000
  Tzone        = -5.0           'must be floating point ie. -5.0 or -1.5 or 7.0



 '       0     1    2     3      4       5
  #0, CLOSED, TCP, UDP, IPRAW, MACRAW, PPPOE
  
DAT     'WIZnet Settings
  mac                   byte    $00, $08, $DC, $16, $F4, $E1
  subnet                byte    255, 255, 255,   0
  gateway               byte    192, 168,   1,   1
  localIP               byte    192, 168,   1, 100

   
VAR
  long  DataStatus                                      'Boolean value used to indicate if last database access sucsessfully retrieved and parsed
  long  longHIGH,longLOW,MM_DD_YYYY,DW_HH_MM_SS         'Used for internet time values and cannot be changed they must maintain order as they are access by adding to a base address
  long  stack[200]
  long  SunsetH,SunsetM
  byte  Wizlock                                         'Used for hub locks
  byte  cog
   
'        seconds                minuets                hours                day of week              date                 month                   year
'byte[@DW_HH_MM_SS][0], byte[@DW_HH_MM_SS][1], byte[@DW_HH_MM_SS][2], byte[@DW_HH_MM_SS][3], byte[@MM_DD_YYYY][2], byte[@MM_DD_YYYY][3], word[@MM_DD_YYYY][0])    
OBJ
  wiz           : "W5200"
  time          : "SNTP 1.3"
  f             : "FloatString"
  n             : "Simple_Numbers"
'  pst           : "parallax serial terminal"
   
PUB Start | i
  wiz.start
  wiz.SetMac(mac[0], mac[1], mac[2], mac[3], mac[4], mac[5])
  wiz.SetSubnetMask(subnet[0], subnet[1], subnet[2], subnet[3])                                                           
  wiz.SetGateway(gateway[0], gateway[1], gateway[2], gateway[3])
  wiz.SetIP(localIP[0], localIP[1], localIP[2], localIP[3])
  wiz.RemoteIP(DataSocket, database[0], database[1], database[2], database[3])
  wiz.SetRemotePort(DataSocket, DatabasePort)
  wiz.RemoteIP(SunSocket, database[0], database[1], database[2], database[3])
  wiz.SetRemotePort(SunSocket, SunPort)
  wizlock := locknew

PUB StartData
  if not cog
    cog := cognew(get_Data, @stack) + 1

PUB StopData
      if cog
        cogstop(cog~ - 1)       ' cog variable is cleared by this statement
    
     
PUB getSwitch(switch)
  return byte[@setting][switch]
  
PUB get_internet_time | i, idx, bytesToRead, temp

  repeat until not lockset(Wizlock)                                                                     'wait until we lock the wiznet chip                              

  wiz.initSocket(sntpSocket,UDP,123)                                                                'initialize socket with local port # 123 and UDP
  wiz.setRemotePort(SNTPsocket,123)                                                                    'Set Remote PORT
  wiz.opensocket(SNTPsocket)

  repeat i from 0 to 16 step 4
    bytemove(@sntpIP, @sntpIp1+i,4)                                                                     'load sntpIP with address to try
    wiz.RemoteIP(SNTPsocket,byte[@sntpIP],byte[@sntpIP+1],byte[@sntpIP+2],byte[@sntpIP+3])      'Set Remote IP address
    bytefill(@Buff,0,Buffsize)
    time.CreateUDPtimeheader(@Buff,@sntpIp)                                                        'Fill the buffer with the udp packet junk to send.
    send(SNTPsocket,@Buff, 48)                                                                'Send the UDP packet

    if recieveSNTPtime
      wiz.closeSocket(SNTPsocket)
      time.GetTransmitTimestamp(-5,true,@Buff,@longHIGH,@LongLOW)
      lockclr(Wizlock)
      return true
    elseif i == 16
      wiz.closeSocket(SNTPsocket)
      lockclr(Wizlock)
      return false
 
PUB get_sunset(Lati,Longi,zone,Mont,D,Yr,DST) | i, idx, local_port, bytesToRead     

  repeat until not lockset(Wizlock)                                  
  local_port := DBstartPort                                                            'Set the Lock variable so no other processes will interfere
  idx := i := 0
  repeat until wiz.IsEstablished(SunSocket)                                    'Keep trying to connect until we are acctually connected  

    if wiz.IsClosed(SunSocket)                                                 'If socket is closed open it
      iniSocket(SunSocket,TCP,local_port)
      wiz.OpenSocket(SunSocket)
      repeat while wiz.IsClosed(SunSocket)                                     'Wait for wiznet to open the socket
        wait(10)

    if wiz.IsCloseWait(SunSocket)                                              'Did the host server disconnect us?
      wiz.closeSocket(SunSocket)
      local_port := wiz.getsocketPort(SunSocket) + 1                           'Increment the local port number and try to connect again
      iniSocket(SunSocket,TCP,local_port)                                      'Configure the socket
      wiz.OpenSocket(SunSocket)
      repeat while wiz.IsClosed(SunSocket)
        wait(10)

    wiz.openRemoteSocket(SunSocket)                                            'try to connect
    wait(50)
    ifnot wiz.IsEstablished(SunSocket)                                         'still not connected??? lets try something else then
      local_port++                                                              'increment local port number to use
      if local_port > DBendPort                                                 'Make sure we start over if port number is higher than end_port
        local_port := DBstartPort
      wiz.SetRemotePort(SunSocket, DatabasePort)
      iniSocket(SunSocket,TCP,local_port)                                      'Re-Configure the socket with next port number to try
      wiz.openRemoteSocket(SunSocket)                                          'try to connect again
      wait(10)

  buildSunsetRequest(Lati,Longi,zone,Mont,D,Yr)
   send(SunSocket, @buff, strsize(@buff))                             'Send request to server  
                                           
  repeat 
    bytesToRead := Available(SunSocket)                                        'Get status of Buffer on Wiznet waits for timeout or data                                                                       
    if(bytesToRead < 0)                                                         'Check for a timeout
      quit                                                                      'exit routine
    if(bytesToRead == 0)                                                        'Check for empty buffer on Wiznet
      quit                                                                      'exit routine 
    if(bytesToRead > 0)                                                         'Check for acctual data to be read
       Receive(SunSocket, @Buff, bytesToRead)                              'store contents of Wiznet buffer into buff array
       quit
      
  bytesToRead~
                                                                                'Reset bytes to read back to zero 

                                                  
  repeat until (Buff[idx] == $22)                                           'cycle throught to the start of the JSON encoded response data (")
    idx++
    if idx => buffsize
      return false
  idx++                                                                         'Move to first Digit
  if (buff[idx] > $30)                                                          'Ensure number is greater than 0
    SunsetH := (buff[idx] - $30) * 10                                           'Move tens of hours into SunsetH
  else
    SunsetH := 0

  idx++                                                                         'Increment to next position of buffer
  if (buff[idx] > $30)                                                          'Ensure number is greater than 0
    SunsetH := SunsetH + (buff[idx] - $30)                                      'Move ones of hours into SunsetH

  idx++                                                                         'Increment to next position of buffer
  idx++                                                                         'Increment to next position of buffer
  if (buff[idx] > $30)
    SunsetM := (buff[idx] - $30) * 10
  else
    SunsetM := 0  
  idx++
  if (buff[idx] > $30)
    SunsetM := SunsetM + (buff[idx] - $30)

  if DST
    SunsetH++      
  lockclr(Wizlock)
return @SunsetH

PUB Get_time_stamp
return @DW_HH_MM_SS

PUB Get_date_stamp
return @MM_DD_YYYY

PUB get_sunsetH
return @sunsetH

PUB get_sunsetM
return @sunsetM

PRI get_Data| local_port, idx, i, bytesToRead, t1, t2

local_port := DBstartPort                                                       'Initialize first local port to be used
repeat
  wait(100)
  repeat until not lockset(wizlock)                                    

  idx := i := 0
  repeat until wiz.IsEstablished(DataSocket)                                    'Keep trying to connect until we are acctually connected  

    if wiz.IsClosed(DataSocket)                                                 'If socket is closed open it
      iniSocket(DataSocket,TCP,local_port)
      wiz.OpenSocket(DataSocket)
      repeat while wiz.IsClosed(DataSocket)                                     'Wait for wiznet to open the socket
        wait(10)

    if wiz.IsCloseWait(DataSocket)                                              'Did the host server disconnect us?
      wiz.closeSocket(DataSocket)
      local_port := wiz.getsocketPort(DataSocket) + 1                           'Increment the local port number and try to connect again
      iniSocket(DataSocket,TCP,local_port)                                      'Configure the socket
      wiz.OpenSocket(DataSocket)
      repeat while wiz.IsClosed(DataSocket)
        wait(10)

    wiz.openRemoteSocket(DataSocket)                                            'try to connect
    wait(50)
    ifnot wiz.IsEstablished(DataSocket)                                         'still not connected??? lets try something else then
      local_port++                                                              'increment local port number to use
      if local_port > DBendPort                                                 'Make sure we start over if port number is higher than end_port
        local_port := DBstartPort
      wiz.SetRemotePort(DataSocket, DatabasePort)
      iniSocket(DataSocket,TCP,local_port)                                      'Re-Configure the socket with next port number to try
      wiz.openRemoteSocket(DataSocket)                                          'try to connect again
      wait(10)
   
  send(DataSocket, @Post_Hdr, strsize(@Post_Hdr))                               'Send request to server  
                                           
  repeat 
    bytesToRead := Available(DataSocket)                                        'Get status of Buffer on Wiznet waits for timeout or data      *****START HERE ******                                                                 
    if(bytesToRead < 0)                                                         'Check for a timeout
      quit                                                                      'exit routine
    if(bytesToRead == 0)                                                        'Check for empty buffer on Wiznet
      quit                                                                      'exit routine 
    if(bytesToRead > 0)                                                         'Check for acctual data to be read
       Receive(DataSocket, @Buff, bytesToRead)                              'store contents of Wiznet buffer into buff array
       quit
      
  bytesToRead~
                                                  
  repeat until (Buff[idx] == "[")                                           'cycle throught to the start of the JSON encoded response data
    idx++
  idx++                                                                         'skip to next position in buffer
  repeat until (Buff[idx] == "]")    
    if (Buff[idx] == $22) or (Buff[idx] == $2C)                         'skip if " or , if found
      idx++
      next
    elseif (Buff[idx] == "0")
      setting[i] := false                                                       'If 0 is found set increase pointer "i"
      i++
    elseif (Buff[idx] == "1")                                               'If 1 is found set bit[i] to high
      setting[i] := true
      i++
    else
      dataStatus := false
      
    idx++
  dataStatus := true
  lockclr(wizlock)

PRI buildSunsetRequest(Lt,Lng,Timezone,Mnth,Dy,Y) | ptr, temp, STpos, BdLength
bytefill(@buff,0,buffSize)                                                      'Clear everything out of buffer
bytemove(@buff,@post_hdr2, strsize(@post_hdr2))                                 'Insert header (including header/body spacing)
StPos := ptr := strsize(@buff)                                                  'Move pointer to ending character and store starting position of body
bytemove(@buff[ptr],@Parameter1,strsize(@Parameter1))                           'Insert Parameter1 text
ptr := strsize(@buff)                                                           'Move pointer to ending character
temp := f.FloatToString(Lt)                                               'Convert latitude to string
bytemove(@buff[ptr],temp,strsize(temp))                                         'Insert Latitude
ptr := strsize(@buff)                                                           'Move pointer to ending character
buff[ptr] := $26                                                                'insert "&"
ptr++                                                                           'Move pointer to ending character
bytemove(@buff[ptr],@Parameter2,strsize(@Parameter2))                           'Insert Patameter2 text
ptr := strsize(@buff)                                                           'Move pointer to ending character
temp := f.FloatToString(Lng)                                              'Convert Longitude to string
bytemove(@buff[ptr],temp,strsize(temp))                                         'Insert Longitude
ptr := strsize(@buff)                                                           'Move pointer to ending character
buff[ptr] := $26                                                                'Insert "&"
ptr++                                                                           'Move pointer to ending character
bytemove(@buff[ptr],@Parameter3,strsize(@Parameter3))                           'Insert Parameter3 text
ptr := strsize(@buff)                                                           'Move pointer to ending character
temp := f.FloatToString(TimeZone)                                                  'Convert time zone into string
bytemove(@buff[ptr],temp,strsize(temp))                                         'Insert Timezone
ptr := strsize(@buff)                                                           'move pointer to ending character
buff[ptr] := $26                                                                'Insert "&"
ptr ++                                                                          'Move pointer to ending character
bytemove(@buff[ptr],@Parameter4,strsize(@Parameter4))                           'Insert Parameter4 text
ptr := strsize(@buff)                                                           'Move pointer to ending character
temp := n.decx(Y,4)                                                          'Convert Year to string
bytemove(@buff[ptr],temp,strsize(temp))                                         'Insert Year
ptr := strsize(@buff)                                                           'Move Pointer to ending character
temp := n.decx(Mnth,2)                                                         'Convert Month to string
bytemove(@buff[ptr],temp,strsize(temp))                                         'Insert Month
ptr := strsize(@buff)                                                           'Move pointer to ending character
temp := n.decx(Dy,2)                                                           'Convert Day to string
bytemove(@buff[ptr],temp,strsize(temp))                                         'Insert day
ptr := strsize(@buff)                                                           'Get end of body
bdLength := ptr - StPos                                                         'Calculate length of body
temp := n.decx(bdlength,2)                                                      'Convert length of body
bytemove(@buff[131],temp,strsize(temp))                                         'Insert Content length overwriting XX in the POST header
                                                                                         
  
PRI recieveSNTPtime | bytesToRead   
 wait(10)
  repeat                                              
    bytesToRead := Available(SNTPSocket)                                                                'get number of bytes to read
    if (bytesToRead < 0)                                                                                'check timeout
      return true
    if (bytesToRead == 0)                                                                               'recieving is done
      return true
    if (bytesToRead > 0)                                                                                'we got work to do
      receive(SNTPsocket,@Buff,bytesToRead)
      if Available(SNTPSocket) == -1
        return true        
    bytesToRead~

  
PRI iniSocket(socket, protocol, portNum)
  wiz.InitSocket(socket, protocol, portNum)
  wiz.SetSocketIR(socket, $FF)
  wiz.SetTimeToLive(socket, 128)


PRI Send(Socket, buffer, len) | bytesToWrite
  bytesToWrite := len
  if(bytesToWrite > wiz.SocketTxSize(Socket))                                   'Will only send up to the buffer size of the socket as configured on the WIZnet
    bytesToWrite := wiz.SocketTxSize(Socket)
  wiz.Tx(Socket, buffer, bytesToWrite)
      return  bytesToWrite                                                      'Should return 0 after successful completion

PRI Available(socket) | i, bytesToRead, tout
  bytesToRead := i := 0

  repeat until null < bytesToRead := wiz.GetRxBytesToRead(socket)
    wait(1)
    if(i++ > DBtimeOut)
      return -1                                                                  'In processes timeout
  
  return bytesToRead

PRI Receive(socket, buffer, bytesToRead) | ptr
  ptr := buffer
  wiz.Rx(socket, buffer, bytesToRead)                                           'Fill local buffer with data from WIZnet
  byte[buffer][bytesToRead] := $00                                              'Last position in local buffer set to $00 (zero terminated string)
  
  if(wiz.getSocketMode(socket) == UDP)                                          'Add to pointer to skip past UDP header
    ptr += $08

  return ptr                                                                    'Send pointer back to calling method (used with UDP as this is the only time its more than 0)
  
PRI wait(delay)
  waitcnt(((clkfreq / 1_000 * delay - 3932) #> 381) + cnt)
      
DAT     'HEADERS
                                           

  Post_Hdr              byte   "POST /electronics/New%20Ideas/testUI/Controller.php HTTP/1.1",13,10,  {
}                              "Host: www.xxxxx.com",13,10,                               {           
}                              "Connection: keep-alive",13,10,                                        {
}                              "Content-Length: 0",13,10,                                             { 
}                              "User-Agent: WebServerXmas",13,10,                                     {           
}                              "Accept: */*",13,10,                                                   {
}                              "Keep-Alive: timeout=15, max=400", 13, 10, 13, 10, 0                   {           
}        
  Post_Hdr2             byte   "POST /electronics/New%20Ideas/testUI/sunset.php HTTP/1.1",13,10,      {  58
}                              "Host: www.xxxxx.com",13,10,                               {  33
}                              "Connection: keep-alive",13,10,                                        {  24  total = 293 bytes header
}                              "Content-Length: XX",13,10,                                            {  20
}                              "User-Agent: WebServerXmas",13,10,                                     {  27
}                              "X-Requested-With: XMLHttpRequest",13,10,                              {  34
}                              "Content-Type: application/x-www-form-urlencoded",13,10,               {  49
}                              "Accept: */*",13,10,                                                   {  13
}                              "Keep-Alive: timeout=15, max=400", 13, 10,13,10,0                      {  35        293 = termination 0            
}
                          
  Parameter1            byte   "Latitude=",0
  Parameter2            byte   "Longitude=",0
  Parameter3            byte   "TimeZone=",0
  Parameter4            byte   "Date=",0                                         


DAT     'Server IP addresses
  sntpIp                byte    111, 111, 111, 111   {Dummy value: Will be automatically replaced by one below.}  
  sntpIp1               byte    128, 138, 141, 172   {U. of Co.  Co. =          128, 138, 141, 172 }        
  sntpIp2               byte    64,  236,  96,  53   {Reston Va =                64, 236,  96,  53 }
  sntpIp3               byte    64,  250, 177, 145   {Atlanta Ga =               64, 250, 177, 145 }   
  sntpIp4               byte    64,  147, 116, 229   {Los Angeles Ca             64, 147, 116, 229 }
  sntpIp5               byte    206, 246, 122, 250   {Hatfield Pa               206, 246, 122, 250 }     '24 bytes

  Database              byte    192, 168,   1,   9
  null                  long    $00        

DAT     'BUFFERS
  setting               byte  $0[11]
  Buff                  byte  $0[BuffSize]
         